package com.example.GridLayoutProblemDemo;

import java.io.Serializable;
import javax.annotation.PostConstruct;
import javax.enterprise.event.Observes;
import javax.inject.Inject;
import com.vaadin.cdi.CDIView;
import com.vaadin.cdi.UIScoped;
import com.vaadin.navigator.View;
import com.vaadin.ui.Button;
import com.vaadin.ui.VerticalLayout;

// @UIScoped - tried, does not work, two instance
// @javax.enterprise.context.SessionScoped - tried, does not work, two instance
// @NormalUIScoped - tried, does not work
// no annotation - work, but what if I want to keep it during the session?
@UIScoped
@CDIView("grid")
public class DemoView extends VerticalLayout implements View, Serializable{

	private static final long serialVersionUID = 1L;
	private int serial=10;
	Button button;
	
	private String thisInfo() {
		return this.getClass().getName()+"/"+this;
	}

	
	@PostConstruct
	public void postConstruct() {
		System.err.println("Post construct:"+thisInfo());
	}
	
	@Inject javax.enterprise.event.Event<GridButtonClickEvent> event;
	
	public DemoView () {
		System.err.println("New: "+thisInfo());
		button = new Button(String.valueOf(serial));
		button.addClickListener(e->{
			event.fire(new GridButtonClickEvent());
		});
		addComponent(button);
	}

	public void onEvent(@Observes GridButtonClickEvent e) {
		System.err.println("Observed an event by: "+thisInfo());
		serial++;
		button.setCaption(String.valueOf(serial));
	}
}
